package vismon.project;

import vismon.data.Session;

import java.awt.*;

//@MessagePackMessage // Annotation
public class Project {

    public String openedDataFilePath;
    public double[] mngOptionMinConstraints;
    public double[] mngOptionMaxConstraints;

    public boolean[] indicatorVisibility;
    public double[] indicatorConstraints;

    //private Scenario[] scenarios;
    public int scenarioNum;
    public String[] scenarioNames;
    public double[] scenarioXMngOptionValues;
    public double[] scenarioYMngOptionValues;
    public int[] scenarioColorRed;
    public int[] scenarioColorGreen;
    public int[] scenarioColorBlue;
    public boolean[] scenarioVisibility;

    public Project() {
        mngOptionMinConstraints = new double[Session.getMngOptionNum()];
        mngOptionMaxConstraints = new double[Session.getMngOptionNum()];

        indicatorVisibility = new boolean[Session.getIndicatorNum()];
        indicatorConstraints = new double[Session.getIndicatorNum()];

        scenarioNum = Session.getScenarios().size();
        scenarioNames = new String[scenarioNum];
        scenarioXMngOptionValues = new double[scenarioNum];
        scenarioYMngOptionValues = new double[scenarioNum];
        scenarioColorRed = new int[scenarioNum];
        scenarioColorGreen = new int[scenarioNum];
        scenarioColorBlue = new int[scenarioNum];
        scenarioVisibility = new boolean[scenarioNum];
    }

    @Override
    public String toString() {
        String output = "";
        output += mngOptionMaxConstraints.length + " MngOptions,";
        output += indicatorConstraints.length + " Indicators,";
        output += scenarioNames.length + " Scenarios.";
        return output;
    }

    public void setIndicatorConstraint(double indicatorConstraint, int rank) {
        this.indicatorConstraints[rank] = indicatorConstraint;
    }

    public void setIndicatorVisibility(boolean indicatorVisibility, int rank) {
        this.indicatorVisibility[rank] = indicatorVisibility;
    }

    public void setMngOptionMaxConstraint(double mngOptionMaxConstraint, int rank) {
        this.mngOptionMaxConstraints[rank] = mngOptionMaxConstraint;
    }

    public void setMngOptionMinConstraint(double mngOptionMinConstraint, int rank) {
        this.mngOptionMinConstraints[rank] = mngOptionMinConstraint;
    }

    public void setOpenedDataFilePath(String openedDataFilePath) {
        this.openedDataFilePath = openedDataFilePath;
    }

    public double getIndicatorConstraint(int rank) {
        return indicatorConstraints[rank];
    }

    public boolean getIndicatorVisibility(int rank) {
        return indicatorVisibility[rank];
    }

    public double getMngOptionMaxConstraint(int rank) {
        return mngOptionMaxConstraints[rank];
    }

    public double getMngOptionMinConstraint(int rank) {
        return mngOptionMinConstraints[rank];
    }

    public String getOpenedDataFilePath() {
        return openedDataFilePath;
    }

    public int getScenarioColorRed(int rank) {
        return scenarioColorRed[rank];
    }

    public void setScenarioColorRed(int scenarioColorRed, int rank) {
        this.scenarioColorRed[rank] = scenarioColorRed;
    }

    public int getScenarioColorBlue(int rank) {
        return scenarioColorBlue[rank];
    }

    public void setScenarioColorBlue(int scenarioColorBlue, int rank) {
        this.scenarioColorBlue[rank] = scenarioColorBlue;
    }

    public int getScenarioColorGreen(int rank) {
        return scenarioColorGreen[rank];
    }

    public void setScenarioColorGreen(int scenarioColorGreen, int rank) {
        this.scenarioColorGreen[rank] = scenarioColorGreen;
    }

    public String getScenarioName(int rank) {
        return scenarioNames[rank];
    }

    public void setScenarioName(String scenarioName, int rank) {
        this.scenarioNames[rank] = scenarioName;
    }

    public double getScenarioXMngOptionValue(int rank) {
        return scenarioXMngOptionValues[rank];
    }

    public void setScenarioXMngOptionValue(double scenarioXMngOptionValue, int rank) {
        this.scenarioXMngOptionValues[rank] = scenarioXMngOptionValue;
    }

    public double getScenarioYMngOptionValue(int rank) {
        return scenarioYMngOptionValues[rank];
    }

    public void setScenarioYMngOptionValue(double scenarioYMngOptionValue, int rank) {
        this.scenarioYMngOptionValues[rank] = scenarioYMngOptionValue;
    }

    public boolean getScenarioVisibility(int rank) {
        return scenarioVisibility[rank];
    }

    public void setScenarioVisibility(boolean scenarioVisibility, int rank) {
        this.scenarioVisibility[rank] = scenarioVisibility;
    }

    public int getScenarioNum() {
        return scenarioNum;
    }
}
